/*****************************************************************************
* OS/2  PM/C Language Demo - PhonePad
* 
*       This demo is intended for comparison with the PhonePad.java 
*       Magercise.
* 
* Copyright 1997, <a href=http://www.MageLang.com>MageLang Institute</a>.
******************************************************************************/
#define INCL_WIN
#define INCL_GPI

#include <os2.h>                        /* PM header file               */
#include "phonepad.h"                   /* Resource symbolic identifiers*/

static HWND CreateButton(HWND hwndParent, LONG Xpos, LONG Ypos,
                         LONG width, LONG height, PCHAR Caption, ULONG wndID);

/*
 * Function prototypes
 */
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

                                        /* Define parameters by type    */
HAB  hab;                               /* PM anchor block handle       */
HWND hwndClient = NULLHANDLE;           /* Client area window handle    */
HWND hwndButton0 = NULLHANDLE;          /* Button 0 window handle       */
HWND hwndButton1 = NULLHANDLE;          /* Button 1 window handle       */
HWND hwndButton2 = NULLHANDLE;          /* Button 2 window handle       */
HWND hwndButton3 = NULLHANDLE;          /* Button 3 window handle       */
HWND hwndButton4 = NULLHANDLE;          /* Button 4 window handle       */
HWND hwndButton5 = NULLHANDLE;          /* Button 5 window handle       */
HWND hwndButton6 = NULLHANDLE;          /* Button 6 window handle       */
HWND hwndButton7 = NULLHANDLE;          /* Button 7 window handle       */
HWND hwndButton8 = NULLHANDLE;          /* Button 8 window handle       */
HWND hwndButton9 = NULLHANDLE;          /* Button 9 window handle       */
HWND hwndButtonP = NULLHANDLE;          /* Button # window handle       */
HWND hwndButtonF = NULLHANDLE;          /* Button * window handle       */
PSZ  pszErrMsg;


INT main (VOID)
{
  HMQ  hmq;                             /* Message queue handle         */
  HWND hwndFrame = NULLHANDLE;          /* Frame window handle          */
  QMSG qmsg;                            /* Message from message queue   */
  ULONG flCreate;                       /* Window creation control flags*/

  if ((hab = WinInitialize(0)) == 0L) /* Initialize PM     */
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

  if ((hmq = WinCreateMsgQueue( hab, 0 )) == 0L)/* Create a msg queue */
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

  if (!WinRegisterClass(                /* Register window class        */
     hab,                               /* Anchor block handle          */
     (PSZ)"MyWindow",                   /* Window class name            */
     (PFNWP)MyWindowProc,               /* Address of window procedure  */
     CS_SIZEREDRAW,                     /* Class style                  */
     0                                  /* No extra window words        */
     ))
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

   flCreate = FCF_STANDARD &            /* Set frame control flags to   */
             ~FCF_SHELLPOSITION;        /* standard except for shell    */
                                        /* positioning.                 */

  if ((hwndFrame = WinCreateStdWindow(
               HWND_DESKTOP,            /* Desktop window is parent     */
               0,                       /* STD. window styles           */
               &flCreate,               /* Frame control flag           */
               "MyWindow",              /* Client window class name     */
               "",                      /* No window text               */
               0,                       /* No special class style       */
               (HMODULE)0L,             /* Resource is in .EXE file     */
               ID_WINDOW,               /* Frame window identifier      */
               &hwndClient              /* Client window handle         */
               )) == 0L)
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

    WinSetWindowText(hwndFrame, "MageLang OS/2 Sample");

  if (!WinSetWindowPos( hwndFrame,      /* Shows and activates frame    */
                   HWND_TOP,            /* window at position 100, 100, */
                   100, 100, 200, 300,  /* and size 200, 300.           */
                   SWP_SIZE | SWP_MOVE | SWP_ACTIVATE | SWP_SHOW
                 ))
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

/*
 * Get and dispatch messages from the application message queue
 * until WinGetMsg returns FALSE, indicating a WM_QUIT message.
 */

  while( WinGetMsg( hab, &qmsg, 0L, 0, 0 ) )
    WinDispatchMsg( hab, &qmsg );
  WinDestroyWindow(hwndFrame);           /* Tidy up...                   */
  WinDestroyMsgQueue( hmq );             /* Tidy up...                   */
  WinTerminate( hab );                   /* Terminate the application    */
  return 0;
} /* End of main */



MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  LONG i;

  switch( msg )
  {
    case WM_CREATE:

      hwndButtonP = CreateButton(
                hwnd,                          /* Parent window          */
                50, 			       /* x position             */
                110,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "#",                           /* Caption                */
                ID_BUTTONP);                   /* Window ID              */ 
      hwndButton0 = CreateButton(
                hwnd,                          /* Parent window          */
                85, 			       /* x position             */
                110,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "0",                           /* Caption                */
                ID_BUTTON0);                   /* Window ID              */ 
      hwndButtonF = CreateButton(
                hwnd,                          /* Parent window          */
                120, 			       /* x position             */
                110,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "*",                           /* Caption                */
                ID_BUTTONF);                   /* Window ID              */ 
      hwndButton1 = CreateButton(
                hwnd,                          /* Parent window          */
                50, 			       /* x position             */
                145,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "1",                           /* Caption                */
                ID_BUTTON1);                   /* Window ID              */ 
      hwndButton2 = CreateButton(
                hwnd,                          /* Parent window          */
                85, 			       /* x position             */
                145,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "2",                           /* Caption                */
                ID_BUTTON2);                   /* Window ID              */ 
      hwndButton3 = CreateButton(
                hwnd,                          /* Parent window          */
                120, 			       /* x position             */
                145,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "3",                           /* Caption                */
                ID_BUTTON3);                   /* Window ID              */ 
      hwndButton4 = CreateButton(
                hwnd,                          /* Parent window          */
                50, 			       /* x position             */
                180,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "4",                           /* Caption                */
                ID_BUTTON4);                   /* Window ID              */ 
      hwndButton5 = CreateButton(
                hwnd,                          /* Parent window          */
                85, 			       /* x position             */
                180,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "5",                           /* Caption                */
                ID_BUTTON5);                   /* Window ID              */ 
      hwndButton6 = CreateButton(
                hwnd,                          /* Parent window          */
                120, 			       /* x position             */
                180,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "6",                           /* Caption                */
                ID_BUTTON6);                   /* Window ID              */ 
      hwndButton7 = CreateButton(
                hwnd,                          /* Parent window          */
                50, 			       /* x position             */
                215,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "7",                           /* Caption                */
                ID_BUTTON7);                   /* Window ID              */ 
      hwndButton8 = CreateButton(
                hwnd,                          /* Parent window          */
                85, 			       /* x position             */
                215,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "8",                           /* Caption                */
                ID_BUTTON8);                   /* Window ID              */ 
      hwndButton9 = CreateButton(
                hwnd,                          /* Parent window          */
                120, 			       /* x position             */
                215,			       /* y position             */
                30, 			       /* width                  */
                30,			       /* height                 */
                "9",                           /* Caption                */
                ID_BUTTON9);                   /* Window ID              */ 
      break;

    case WM_COMMAND:
      /*
       * When Exit is chosen, the application posts itself a WM_CLOSE
       * message.
       */
      {
         USHORT command;                   /* WM_COMMAND command value     */
         command = SHORT1FROMMP(mp1);      /* Extract the command value    */
         switch (command)
         {
           case ID_EXITPROG:
             WinPostMsg( hwnd, WM_CLOSE, (MPARAM)0, (MPARAM)0 );
             break;
           default:
             return WinDefWindowProc( hwnd, msg, mp1, mp2 );
         }

         break;
      }
    case WM_ERASEBACKGROUND:
      /*
       * Return TRUE to request PM to paint the window background
       * in SYSCLR_WINDOW.
       */
      return (MRESULT)( TRUE );
    case WM_CLOSE:
      /*
       * This is the place to put termination routines
       */
      WinPostMsg( hwnd, WM_QUIT, (MPARAM)0,(MPARAM)0 );
      break;
    default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }
  return (MRESULT)FALSE;
} /* End of MyWindowProc */

VOID AbortProgram(HWND hwndFrame, HWND hwndClient)
{
   PERRINFO  pErrInfoBlk;
   PSZ       pszOffSet;
   void      stdprint(void);

   DosBeep(100,10);
   if ((pErrInfoBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL)
   {
      pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
      pszErrMsg = ((PSZ)pErrInfoBlk) + *((PSHORT)pszOffSet);
      if((INT)hwndFrame && (INT)hwndClient)
         WinMessageBox(HWND_DESKTOP,         /* Parent window is desk top */
                       hwndFrame,            /* Owner window is our frame */
                       (PSZ)pszErrMsg,       /* PMWIN Error message       */
                       "Error Msg",          /* Title bar message         */
                       MSGBOXID,             /* Message identifier        */
                       MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      WinFreeErrorInfo(pErrInfoBlk);
   }
   WinPostMsg(hwndClient, WM_QUIT, (MPARAM)NULL, (MPARAM)NULL);
} /* End */


/*****************************************************************************
* Convenience function to create buttons.
*****************************************************************************/
static HWND CreateButton(HWND hwndParent, LONG Xpos, LONG Ypos,
                         LONG width, LONG height, PCHAR Caption, ULONG wndID)
{
   HWND hwnd =
   WinCreateWindow(
                hwndParent,                    /* Parent window          */
                WC_BUTTON,                     /* Window class           */
                Caption,                       /* Window text            */
                WS_VISIBLE |
                BS_PUSHBUTTON |
                BS_AUTOSIZE,                   /* Button style           */
                Xpos, 			       /* x position             */
                Ypos,			       /* y position             */
                width,      		       /* Width                  */
                height,                        /* Height                 */
                hwndParent,                    /* Owner window           */
                HWND_TOP,                      /* Top of z-order         */
                wndID,                         /* Window identifier      */
                NULL,                          /* Control data           */
                NULL);                         /* Presentation parameters*/
   
   return hwnd;
} 