/*****************************************************************************
* OS/2  PM/C Language Demo - Menus
* 
*       This demo is intended for comparison with the MenuTest.java 
*       Magercise.
* 
* Copyright 1997, <a href=http://www.MageLang.com>MageLang Institute</a>.
******************************************************************************/
#define INCL_WIN
#define INCL_GPI

#include <os2.h>                        /* PM header file               */
#include <string.h>                     /* for strcpy, strcat           */
#include <stdio.h>                      /* for sprintf                  */
#include "menus.h"                      /* Resource symbolic identifiers*/

/*
 * Function prototypes
 */
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

                                        /* Define parameters by type    */
HAB  hab;                               /* PM anchor block handle       */
HWND hwndFrame = NULLHANDLE;            /* Frame window handle          */
HWND hwndClient = NULLHANDLE;           /* Client area window handle    */
HWND hwndListBox1 = NULLHANDLE;         /* List Box 1 window handle     */
CHAR szMenu1[40] = "";
CHAR szWork[100] = "";
PSZ  pszErrMsg;


INT main (VOID)
{
  HMQ  hmq;                             /* Message queue handle         */
  QMSG qmsg;                            /* Message from message queue   */
  ULONG flCreate;                       /* Window creation control flags*/

  if ((hab = WinInitialize(0)) == 0L) /* Initialize PM     */
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

  if ((hmq = WinCreateMsgQueue( hab, 0 )) == 0L)/* Create a msg queue */
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

  if (!WinRegisterClass(                /* Register window class        */
     hab,                               /* Anchor block handle          */
     (PSZ)"MyWindow",                   /* Window class name            */
     (PFNWP)MyWindowProc,               /* Address of window procedure  */
     CS_SIZEREDRAW,                     /* Class style                  */
     0                                  /* No extra window words        */
     ))
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

   flCreate = FCF_STANDARD &            /* Set frame control flags to   */
             ~FCF_SHELLPOSITION;        /* standard except for shell    */
                                        /* positioning.                 */

  if ((hwndFrame = WinCreateStdWindow(
               HWND_DESKTOP,            /* Desktop window is parent     */
               0,                       /* STD. window styles           */
               &flCreate,               /* Frame control flag           */
               "MyWindow",              /* Client window class name     */
               "",                      /* No window text               */
               0,                       /* No special class style       */
               (HMODULE)0L,             /* Resource is in .EXE file     */
               ID_WINDOW,               /* Frame window identifier      */
               &hwndClient              /* Client window handle         */
               )) == 0L)
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

    WinSetWindowText(hwndFrame, "MageLang OS/2 Sample");

  if (!WinSetWindowPos( hwndFrame,      /* Shows and activates frame    */
                   HWND_TOP,            /* window at position 100, 100, */
                   100, 100, 500, 400,  /* and size 500, 400.           */
                   SWP_SIZE | SWP_MOVE | SWP_ACTIVATE | SWP_SHOW
                 ))
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

/*
 * Get and dispatch messages from the application message queue
 * until WinGetMsg returns FALSE, indicating a WM_QUIT message.
 */

  while( WinGetMsg( hab, &qmsg, 0L, 0, 0 ) )
    WinDispatchMsg( hab, &qmsg );
  WinDestroyWindow(hwndFrame);           /* Tidy up...                   */
  WinDestroyMsgQueue( hmq );             /* Tidy up...                   */
  WinTerminate( hab );                   /* Terminate the application    */
  return 0;
} /* End of main */



MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  static INT LboxNum =0;

  switch( msg )
  {
    case WM_CREATE:
      hwndListBox1 = WinCreateWindow(
                hwnd,                          /* Parent window          */
                WC_LISTBOX,                    /* Window class           */
                "",                            /* Window text            */
                WS_VISIBLE |                   /* Make it visible        */
                LS_NOADJUSTPOS,                /* List Box Options       */
                20, 			       /* x position             */
                20,			       /* y position             */
                400,      		       /* Width                  */
                300,                           /* Height                 */
                hwnd,                          /* Owner window           */
                HWND_TOP,                      /* Top of z-order         */
                ID_LISTBOX1,                   /* Window identifier      */
                NULL,                          /* Control data           */
                NULL);                         /* Presentation parameters*/
      break;

    case WM_COMMAND:
      /*
       * When Exit is chosen, the application posts itself a WM_CLOSE
       * message.
       */
      {
         USHORT command;                   /* WM_COMMAND command value     */
         command = SHORT1FROMMP(mp1);      /* Extract the command value    */
         switch (command)
         {
           case ID_OPENFILE:
           case ID_CLOSEFILE:
             {
                MENUITEM mi;
                HWND hwndSrc;
                HWND hwndMenu = WinWindowFromID(hwndFrame, FID_MENU);
                WinSendMsg(hwndMenu,                       /* Handle of menu bar  */
                           MM_QUERYITEMTEXT,               /* Message             */
                           MPFROM2SHORT(command, 32),      /* Submenu identifier  */
                           szMenu1);                       /* Pointer to String   */
                sprintf(szWork, "Selected FileMenu  %s", szMenu1);
                WinInsertLboxItem(hwndListBox1, LIT_END, szWork);
             }
             break;
           case ID_HELPITEM1:
           case ID_HELPITEM2:
           case ID_HELPITEM3:
           case ID_HELPITEM4:
           case ID_HELPITEM5:
           case ID_HELPITEM6:
           case ID_HELPITEM7:
           case ID_HELPITEM8:
             {
                MENUITEM mi;
                HWND hwndSrc;
                HWND hwndMenu = WinWindowFromID(hwndFrame, FID_MENU);
                WinSendMsg(hwndMenu,                       /* Handle of menu bar  */
                           MM_QUERYITEMTEXT,               /* Message             */
                           MPFROM2SHORT(command, 32),      /* Submenu identifier  */
                           szMenu1);                       /* Pointer to String   */
                WinInsertLboxItem(hwndListBox1, LIT_END, szMenu1);
             }
             break;
           case ID_EXITPROG:
             WinPostMsg( hwnd, WM_CLOSE, (MPARAM)0, (MPARAM)0 );
             break;
           default:
             return WinDefWindowProc( hwnd, msg, mp1, mp2 );
         }

         break;
      }
    case WM_ERASEBACKGROUND:
      /*
       * Return TRUE to request PM to paint the window background
       * in SYSCLR_WINDOW.
       */
      return (MRESULT)( TRUE );
    case WM_CLOSE:
      /*
       * This is the place to put termination routines
       */
      WinPostMsg( hwnd, WM_QUIT, (MPARAM)0,(MPARAM)0 );
      break;
    default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }
  return (MRESULT)FALSE;
} /* End of MyWindowProc */

VOID AbortProgram(HWND hwndFrame, HWND hwndClient)
{
   PERRINFO  pErrInfoBlk;
   PSZ       pszOffSet;
   void      stdprint(void);

   DosBeep(100,10);
   if ((pErrInfoBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL)
   {
      pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
      pszErrMsg = ((PSZ)pErrInfoBlk) + *((PSHORT)pszOffSet);
      if((INT)hwndFrame && (INT)hwndClient)
         WinMessageBox(HWND_DESKTOP,         /* Parent window is desk top */
                       hwndFrame,            /* Owner window is our frame */
                       (PSZ)pszErrMsg,       /* PMWIN Error message       */
                       "Error Msg",          /* Title bar message         */
                       MSGBOXID,             /* Message identifier        */
                       MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      WinFreeErrorInfo(pErrInfoBlk);
   }
   WinPostMsg(hwndClient, WM_QUIT, (MPARAM)NULL, (MPARAM)NULL);
} /* End */

